package com.ruoyi.platform.mapper;

import com.ruoyi.platform.domain.ModelDependency;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;
import java.util.List;

/**
 * (ModelDependency)表数据库访问层
 *
 * @author Xidaray
 * @since 2024-05-29 13:51:23
 */
public interface ModelDependencyDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ModelDependency queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param modelDependency 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<ModelDependency> queryAllByLimit(ModelDependency modelDependency, @Param("pageable") Pageable pageable);



    /**
     * 统计总行数
     *
     * @param modelDependency 查询条件
     * @return 总行数
     */
    long count(ModelDependency modelDependency);

    /**
     * 新增数据
     *
     * @param modelDependency 实例对象
     * @return 影响行数
     */
    int insert(ModelDependency modelDependency);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<ModelDependency> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<ModelDependency> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<ModelDependency> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<ModelDependency> entities);

    /**
     * 修改数据
     *
     * @param modelDependency 实例对象
     * @return 影响行数
     */
    int update(ModelDependency modelDependency);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<ModelDependency> queryByModelDependency(@Param("modelDependency") ModelDependency modelDependency);

    List<ModelDependency> queryChildrenByVersionId(@Param("model_id")String modelId, @Param("version")String version);

    List<ModelDependency> queryByIns(@Param("expInsId")Integer expInsId);

    ModelDependency queryByInsAndTrainTaskId(@Param("expInsId")Integer expInsId,@Param("taskId") String taskId);
}

